<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0" />
		<title></title>
		<!-- Link boostrap 4-->
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

		<!-- Link fontawesome-->
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />

		<!-- Data Table-->
		<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
		<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
		<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
	</head>

	<body>
		<div class="container-fluid">
			<h3 class="text-center my-2">Danh sách đơn hàng</h3>

			<!-- Table of orders -->
			<table class="table table-hover table-bordered table-striped" id="table-orders">
				<thead>
					<tr>
						<th>Order Code</th>
						<th>Kích cỡ Combo</th>
						<th>Loại Pizza</th>
						<th>Nước uống</th>
						<th>Thành tiền</th>
						<th>Họ và tên</th>
						<th>Số điện thoại</th>
						<th>Trạng thái</th>
						<th>Chi tiết</th>
					</tr>
				</thead>
				<tbody></tbody>
			</table>
			<!-- Modal Detail -->
			<div id="modal-detail" class="modal fade" role="dialog">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h4 class="modal-title">Order Detail</h4>
						</div>
						<div class="modal-body">
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Order Code</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-order-code" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Kích cỡ</label>
								</div>
								<div class="col-9">
									<select class="form-control" id="sel-size">
										<option value="S">Small</option>
										<option value="M">Medium</option>
										<option value="L">Large</option>
									</select>
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Đường kính</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-duong-kinh" />
								</div>
							</div>

							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Sườn</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-suon" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Salad</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-salad" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Loại Pizza</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-loai-pizza" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Id Voucher</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-id-vourcher" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Thành tiền</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-thanh-tien" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Giảm giá</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-giam-gia" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Loại đồ uống</label>
								</div>
								<div class="col-9">
									<select class="form-control" id="sel-id-loai-nuoc-uong"></select>
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Số lượng nước uống</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-so-luong-nuoc" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Họ và tên</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-ho-ten" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Email</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-email" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Số điện thoại</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-so-dien-thoai" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Địa chỉ</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-dia-chi" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Lời nhắn</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-loi-nhan" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Ngày order</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-ngay-tao" />
								</div>
							</div>
							<div class="row form-group">
								<div class="col-3">
									<label class="form-label">Ngày chỉnh sửa</label>
								</div>
								<div class="col-9">
									<input type="text" class="form-control" id="inp-ngay-cap-nhat" />
								</div>
							</div>
						</div>
						<div class="modal-footer">
							<div class="row w-100">
								<div class="col-6">
									<button type="button" class="btn btn-warning w-100" id="btn-confirm">Confirm</button>
								</div>
								<div class="col-6">
									<button type="button" class="btn btn-danger w-100" id="btn-cancel">Cancel</button>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</body>
	<script>
		"use strict";
		/*** REGION 1 - Global variables */
		var gOrdersList = [];
		var gCOL_NAME = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "chiTiet"];
		var gCOL_ORDER_CODE = 0;
		var gCOL_KICH_CO = 1;
		var gCOL_LOAI_PIZZA = 2;
		var gCOL_NUOC_UONG = 3;
		var gCOL_THANH_TIEN = 4;
		var gCOL_HO_TEN = 5;
		var gCOL_SO_DIEN_THOAI = 6;
		var gCOL_TRANG_THAI = 7;
		var gCOL_CHI_TIET = 8;

		var gOrdersTable = $("#table-orders").DataTable({
			columns: [
				{ data: gCOL_NAME[gCOL_ORDER_CODE] },
				{ data: gCOL_NAME[gCOL_KICH_CO] },
				{ data: gCOL_NAME[gCOL_LOAI_PIZZA] },
				{ data: gCOL_NAME[gCOL_NUOC_UONG] },
				{ data: gCOL_NAME[gCOL_THANH_TIEN] },
				{ data: gCOL_NAME[gCOL_HO_TEN] },
				{ data: gCOL_NAME[gCOL_SO_DIEN_THOAI] },
				{ data: gCOL_NAME[gCOL_TRANG_THAI] },
				{ data: gCOL_NAME[gCOL_CHI_TIET] },
			],
			columnDefs: [
				{
					targets: gCOL_CHI_TIET,
					defaultContent: `<button class="btn btn-primary btn-detail">Chi tiết</button>`,
				},
			],
		});

		var gId;
		var gOrderCode;
		/*** REGION 2 - Elements' events declaration */
		onPageLoading();

		//add event to detail btn
		$("#table-orders").on("click", ".btn-detail", function () {
			onBtnDetailClick(this);
		});

		//load event to confirm button
		$("#btn-confirm").on("click", function () {
			onBtnConfirmClick();
		});

		//load event to cancel button
		$("#btn-cancel").on("click", function () {
			onBtnCancelClick();
		});

		/*** REGION 3 - Event handlers */
		//runs when Detail btn is clicked
		function onBtnDetailClick(paramBtnDetail) {
			var vRow = $(paramBtnDetail).closest("tr");
			var vRowData = gOrdersTable.row(vRow).data();
			console.log(vRowData);
			gId = vRowData.id;
			gOrderCode = vRowData.orderCode;
			console.log(gId);
			console.log(gOrderCode);
			$("#modal-detail").modal("show");
			callAPIGetOrderDetail(gOrderCode);
		}
		//runs when Confirm btn is clicked
		function onBtnConfirmClick() {
			console.log(gId);

			var vOrderStatus = {
				trangThai: "confirmed",
			};
			callAPIUpdateOrderStatus(vOrderStatus, gId);
		}

		//runs when Cancel btn is clicked
		function onBtnCancelClick() {
			console.log(gId);

			var vOrderStatus = {
				trangThai: "cancel",
			};
			callAPIUpdateOrderStatus(vOrderStatus, gId);
		}

		//runs when page load
		function onPageLoading() {
			callAPIGetOrdersList();
		}
		/*** REGION 4 - Common funtions */
		//load order data to modal
		//input: order data
		function loadDataToOrderDetail(paramOrderObj) {
			$("#inp-order-code").val(paramOrderObj.orderCode);
			$("#sel-size").val(paramOrderObj.kichCo);
			$("#inp-duong-kinh").val(paramOrderObj.duongKinh);
			$("#inp-suon").val(paramOrderObj.suon);
			$("#inp-salad").val(paramOrderObj.salad);
			$("#inp-loai-pizza").val(paramOrderObj.loaiPizza);
			$("#inp-id-vourcher").val(paramOrderObj.idVourcher);
			$("#inp-thanh-tien").val(paramOrderObj.thanhTien);
			$("#inp-giam-gia").val(paramOrderObj.giamGia);
			$("#sel-id-loai-nuoc-uong").val(paramOrderObj.idLoaiNuocUong);
			$("#inp-so-luong-nuoc").val(paramOrderObj.soLuongNuoc);
			$("#inp-ho-ten").val(paramOrderObj.hoTen);
			$("#inp-email").val(paramOrderObj.email);
			$("#inp-so-dien-thoai").val(paramOrderObj.soDienThoai);
			$("#inp-dia-chi").val(paramOrderObj.diaChi);
			$("#inp-loi-nhan").val(paramOrderObj.loiNhan);
			$("#inp-ngay-tao").val(paramOrderObj.ngayTao);
			$("#inp-ngay-cap-nhat").val(paramOrderObj.ngayCapNhat);
		}
		//call api to get order detail
		//input: order code of an order
		function callAPIGetOrderDetail(paramOrderCode) {
			$.ajax({
				type: "GET",
				url: "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + paramOrderCode,
				success: function (paramRes) {
					loadDataToOrderDetail(paramRes);
				},
				error: function (paramErr) {
					alert("Không lấy được chi tiết đơn hàng");
				},
			});
		}
		//call api to get orders list
		function callAPIGetOrdersList() {
			$.ajax({
				type: "GET",
				url: "http://203.171.20.210:8080/devcamp-pizza365/orders",

				success: function (paramRes) {
					gOrdersList = paramRes;
					console.log(gOrdersList);
					loadOrdersListToTable(gOrdersList);
				},
				error: function (paramErr) {
					alert("Không lấy được danh sách đơn hàng");
				},
			});
		}

		//load orders list to table
		//input: list of orders to load
		function loadOrdersListToTable(paramOrdersList) {
			gOrdersTable.clear();
			gOrdersTable.rows.add(paramOrdersList);
			gOrdersTable.draw();
		}

		//call api to update an order
		//input: order status obj and id of order
		function callAPIUpdateOrderStatus(paramOrderStatusObj, paramId) {
			$.ajax({
				type: "PUT",
				url: "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + paramId,
				data: JSON.stringify(paramOrderStatusObj),
				contentType: "application/json;charset=UTF-8",
				success: function () {
					$("#modal-detail").modal("hide");
					callAPIGetOrdersList();
				},
				error: function () {
					alert("Không update được trạng thái đơn hàng");
				},
			});
		}
	</script>
</html>
